           (*-------------------------------------------*
            |                Csp-Prover                 |
            |              September 2004               |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory CPO_pair = CPO:

(*****************************************************************

         1. Pairs of CPO are also CPO.
         2. 
         3. 
         4. 

 *****************************************************************)

(*  Take care the following rules automatically applied                *)
(*                                                                     *)
(*          split_paired_Ex:  (EX x. P x) = (EX a b. P (a, b))         *)
(*          split_paired_All: (ALL x. P x) = (ALL a b. P (a, b))       *)

(********************************************************** 
              def: pair of bot
 **********************************************************)

instance * :: (bot, bot) bot0
apply (intro_classes)
done

defs (overloaded)
  pair_Bot_def : "Bot == (Bot, Bot)"

(************************************************************
                   Pairuct bot ==> bot
 ************************************************************)

(*** pair Bot ***)

lemma pair_Bot:
  "ALL (x::('x::bot * 'y::bot)). Bot <= x"
apply (simp add: order_pair_def)
apply (auto simp add: pair_Bot_def bottom_bot)
done

(*****************************
       Pair bot => bot
 *****************************)

instance * :: (bot, bot) bot
apply (intro_classes)
apply (simp add: pair_Bot)
done

(************************************************************
                   Pair CPO ==> CPO
 ************************************************************)

(*** pair directed decompo ***)

lemma pair_directed_decompo_fst:
  "ALL (Xc::('x::cpo * 'y::cpo) set).
     directed Xc --> directed {fst xc |xc. xc : Xc}"
apply (intro allI impI)
apply (simp add: directed_def)
apply (auto)
apply (rename_tac Xc a b x1 y1 x2 y2)
apply (drule_tac x="x1" in spec)
apply (drule_tac x="x2" in spec)
apply (drule_tac x="y1" in spec)
apply (drule_tac x="y2" in spec)
apply (simp)

apply (elim conjE exE)
apply (rule_tac x="aa" in exI)
apply (auto simp add: order_pair_def)
done

lemma pair_directed_decompo_snd:
  "ALL (Xc::('x::cpo * 'y::cpo) set).
     directed Xc --> directed {snd xc |xc. xc : Xc}"
apply (intro allI impI)
apply (simp add: directed_def)
apply (auto)
apply (rename_tac Xc a b x2 y2 x1 y1)
apply (drule_tac x="x1" in spec)
apply (drule_tac x="x2" in spec)
apply (drule_tac x="y1" in spec)
apply (drule_tac x="y2" in spec)
apply (simp)

apply (elim conjE exE)
apply (rule_tac x="ba" in exI)
apply (auto simp add: order_pair_def)
done

(*** pair cpo lemma ***)

lemma pair_cpo_lm:
  "ALL (Xc::('x::cpo * 'y::cpo) set). directed Xc --> (EX x. Xc <<| x)"
apply (intro allI impI)
apply (rule_tac 
  x="(LUB {fst xc |xc. xc : Xc}, LUB {snd xc |xc. xc : Xc})" in exI)
apply (rule pair_lub_decompoI)

apply (insert pair_directed_decompo_fst)
apply (insert pair_directed_decompo_snd)
apply (drule_tac x="Xc" in spec)
apply (drule_tac x="Xc" in spec)
apply (simp)

apply (insert complete_cpo_lm)
apply (drule_tac x="{u. EX b. (u, b) : Xc}" in spec)
apply (simp)
apply (erule exE)
apply (insert complete_cpo_lm)
apply (drule_tac x="{u. EX a. (a, u) : Xc}" in spec)
apply (simp)
apply (erule exE)
apply (simp add: LUB_lub)
done

(*****************************
       Pair CPO => CPO
 *****************************)

instance * :: (cpo,cpo) cpo
apply (intro_classes)
apply (simp add: pair_cpo_lm del: split_paired_Ex)
done

(************************************************************
                Pairuct CPO_BOT ==> CPO_BOT
 ************************************************************)

instance * :: (cpo_bot,cpo_bot) cpo_bot
apply (intro_classes)
done

(************************************************************
                     fst continuity
 ************************************************************)

lemma fst_cont: "cont (fst)"
apply (simp add: cont_iff)
apply (intro allI impI)
apply (insert complete_cpo_lm)
apply (drule_tac x="X" in spec)
apply (simp)

apply (erule exE)
apply (rule_tac x="a" in exI)
apply (simp add: fst_snd_lub)
done

lemma snd_cont: "cont (snd)"
apply (simp add: cont_iff)
apply (intro allI impI)
apply (insert complete_cpo_lm)
apply (drule_tac x="X" in spec)
apply (simp)

apply (elim exE)
apply (rule_tac x="a" in exI)
apply (rule_tac x="b" in exI)
apply (simp add: fst_snd_lub)
done

(************************************************************
                   Pair continuity
 ************************************************************)

lemma pair_cont_imp: 
  "ALL (h :: (('x::cpo) => (('y::cpo) * ('z::cpo)))). 
      cont h --> (cont(fst o h) & cont(snd o h))"
apply (intro allI impI)
apply (simp add: fst_cont snd_cont compo_cont)
done

lemma pair_cont_if: 
  "ALL (h :: (('x::cpo) => (('y::cpo) * ('z::cpo)))). 
      (cont(fst o h) & cont(snd o h)) --> cont h"
apply (intro allI impI)
apply (simp add: cont_iff)
apply (insert complete_cpo_lm)
apply (intro allI impI)
apply (drule_tac x="X" in spec)
apply (simp)

apply (erule exE)
apply (rule_tac x="x" in exI)
apply (simp)

apply (simp add: fst_snd_lub_x)
apply (erule conjE)
apply (drule_tac x="X" in spec)
apply (drule_tac x="X" in spec)
apply (simp)

apply (elim exE)
apply (insert lub_unique)
apply (drule_tac x="X" in spec)
apply (drule_tac x="xa" in spec)
apply (drule_tac x="x" in spec)
apply (insert lub_unique)
apply (drule_tac x="X" in spec)
apply (drule_tac x="xb" in spec)
apply (drule_tac x="x" in spec)
apply (simp add: image_compose)
done

lemma pair_cont: 
  "cont h = (cont(fst o h) & cont(snd o h))"
apply (rule iffI)
apply (simp add: pair_cont_imp)
apply (simp add: pair_cont_if)
done

end

