           (*-------------------------------------------*
            |                Csp-Prover                 |
            |              September 2004               |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory CPO_prod = CPO:

(*****************************************************************

         1. Productions of CPO are also CPO.
         2. 
         3. 
         4. 

 *****************************************************************)

(********************************************************** 
              def: prod of bot
 **********************************************************)

instance fun :: (type, bot) bot0
apply (intro_classes)
done

defs (overloaded)
  prod_Bot_def : "Bot == (%i. Bot)"

(************************************************************
                   Product bot ==> bot
 ************************************************************)

(*** prod Bot ***)

lemma prod_Bot:
  "ALL (x::('i => 'x::bot)). Bot <= x"
apply (simp add: order_prod_def)
apply (simp add: prod_Bot_def)
apply (simp add: bottom_bot)
done

(*****************************
       Prod bot => bot
 *****************************)

instance fun :: (type,bot) bot
apply (intro_classes)
apply (simp add: prod_Bot)
done

(************************************************************
                   Product CPO ==> CPO
 ************************************************************)

(*** prod directed decompo ***)

lemma prod_directed_decompo:
  "ALL (Xp::('i => 'x::cpo) set).
     directed Xp --> (ALL i. directed {xp i |xp. xp : Xp})"
apply (intro allI impI)
apply (simp add: directed_def)
apply (intro allI impI)
apply (elim conjE exE)
apply (rename_tac Xp i x y xp yp)

apply (drule_tac x="xp" in spec)
apply (drule_tac x="yp" in spec)
apply (simp)
apply (elim conjE exE)

apply (rule_tac x="z i" in exI)
apply (auto simp add: order_prod_def)
done

(*** prod cpo lemma ***)

lemma prod_cpo_lm:
  "ALL (Xp::('i => 'x::cpo) set). directed Xp --> (EX x. Xp <<| x)"
apply (intro allI impI)
apply (rule_tac x="(%i. LUB {xp i |xp. xp : Xp})" in exI)
apply (rule prod_lub_decompoI)
apply (intro allI)

apply (insert prod_directed_decompo)
apply (drule_tac x="Xp" in spec)
apply (simp)
apply (drule_tac x="i" in spec)

apply (insert complete_cpo_lm)
apply (drule_tac x="{xp i |xp. xp : Xp}" in spec)
apply (simp)
apply (erule exE)
apply (simp add: LUB_lub)
done

(*****************************
       Prod CPO => CPO
 *****************************)

instance fun :: (type,cpo) cpo
apply (intro_classes)
apply (simp add: prod_cpo_lm)
done

(************************************************************
                Product CPO_BOT ==> CPO_BOT
 ************************************************************)

instance fun :: (type,cpo_bot) cpo_bot
apply (intro_classes)
done

(************************************************************
                   Project continuity
 ************************************************************)

lemma proj_cont: "ALL i. cont (proj_fun i)"
apply (simp add: cont_iff)
apply (intro allI impI)
apply (insert complete_cpo_lm)
apply (drule_tac x="X" in spec)
apply (simp)

apply (erule exE)
apply (rule_tac x="x" in exI)
apply (simp add: proj_lub)
done

(************************************************************
                   Product continuity
 ************************************************************)

lemma prod_cont_imp: 
  "ALL (h :: (('x::cpo) => ('i =>('y::cpo)))). 
      cont h --> (ALL i. cont((proj_fun i) o h))"
apply (intro allI impI)
apply (simp add: proj_cont compo_cont)
done

lemma prod_cont_if: 
  "ALL (h :: (('x::cpo) => ('i =>('y::cpo)))). 
      (ALL i. cont((proj_fun i) o h)) --> cont h"
apply (intro allI impI)
apply (simp add: cont_iff)
apply (insert complete_cpo_lm)
apply (intro allI impI)
apply (drule_tac x="X" in spec)
apply (simp)

apply (erule exE)
apply (rule_tac x="x" in exI)
apply (simp)

apply (simp add: proj_lub)
apply (intro allI)
apply (drule_tac x="i" in spec)
apply (drule_tac x="X" in spec)
apply (simp)

apply (erule exE)
apply (insert lub_unique)
apply (drule_tac x="X" in spec)
apply (drule_tac x="xa" in spec)
apply (drule_tac x="x" in spec)
apply (simp add: image_compose)
done

lemma prod_cont: 
  "cont h = (ALL i. cont((proj_fun i) o h))"
apply (rule iffI)
apply (simp add: prod_cont_imp)
apply (simp add: prod_cont_if)
done

end

