           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_Rename = Csp_semantics:

(*****************************************************************

         1. T [[r]]t : dom_T
         2. F [[r]]f : dom_F
         3. SF [[r]]sf : dom_SF
         4. 

 *****************************************************************)

(*********************************************************
                 Lemma (Hidet in Dom_T)
 *********************************************************)

lemma Renamet_in : 
  "ALL r S. S:dom_T --> S [[r]]t: dom_T"
apply (intro allI impI)

apply (simp (no_asm) add: dom_T_def CT1_def)

  (* non-empty *)

apply (rule conjI)
apply (simp add: Renamet_def)
apply (rule_tac x="[]t" in exI)
apply (rule_tac x="[]t" in bexI)
apply (simp add: ren_nil)
apply (simp add: nil_t_in_all_dom)

  (* prefix closed *)

apply (simp add: prefix_closed_def)
apply (intro allI impI)
apply (simp add: Renamet_def)
apply (elim conjE exE bexE)
apply (rename_tac r S v u s)

apply (insert ren_prefix)
apply (drule_tac x="r" in spec)
apply (drule_tac x="v" in spec)
apply (drule_tac x="u" in spec)
apply (drule_tac x="s" in spec)
apply (simp)
apply (elim conjE exE)
apply (rule_tac x="t" in bexI)
apply (simp)

apply (simp add: dom_T_def CT1_def)
apply (blast intro: prefix_closed_propI)
done

(*********************************************************
                 Lemma (Renamef in Dom_F)
 *********************************************************)

lemma Renamef_in : 
  "ALL r S. S:dom_F --> S [[r]]f: dom_F"
apply (intro allI impI)

apply (simp (no_asm) add: dom_F_def CF1_def)
apply (intro allI impI)

apply (simp add: Renamef_def)
apply (elim conjE exE)
apply (rename_tac r S s X Y t)
apply (rule_tac x="t" in exI)
apply (simp)

apply (simp add: dom_F_def)
apply (unfold CF1_def)

apply (drule_tac x="t" in spec)
apply (drule_tac x="<invEv r> X" in spec)
apply (drule_tac x="<invEv r> Y" in spec)
apply (simp add: invrelfun_sub)
done

(*********************************************************
                 Lemma (Renamesf in Dom_SF)
 *********************************************************)

(*** T2 ***)

lemma Renamesf_in_T2 : "ALL r TF. TF:dom_SF --> CT2(TF [[r]]sf)"
apply (intro allI impI)
apply (simp add: Renamesf_def CT2_def)
apply (intro allI impI)
apply (simp add: Renamet_in Rep_dom_T Abs_dom_T_inverse)
apply (simp add: Renamef_in Rep_dom_F Abs_dom_F_inverse)

apply (simp add: Renamet_def)
apply (elim conjE exE bexE)
apply (rename_tac r TF s tt)

apply (insert ren_decompo_from)
apply (drule_tac x="r" in spec)
apply (drule_tac x="s" in spec)
apply (drule_tac x="[Tick]t" in spec)
apply (drule_tac x="tt" in spec)
apply (simp)
apply (elim conjE exE)

apply (insert ren_from_tick)
apply (drule_tac x="r" in spec)
apply (drule_tac x="s2" in spec)
apply (simp)

apply (simp add: dom_SF_def CT2_def)
apply (erule conjE)+
apply (drule_tac x="s1" in spec)

apply (insert ren_from_notick)
apply (drule_tac x="r" in spec)
apply (drule_tac x="s" in spec)
apply (drule_tac x="s1" in spec)
apply (simp)
apply (elim conjE)

apply (simp add: Renamef_def)
apply (rule conjI)
apply (rule_tac x="s1" in exI)
apply (simp)

apply (insert dom_F_F1)
apply (drule_tac x="s1" in spec)
apply (drule_tac x="Evset" in spec)
apply (drule_tac x="<invEv r> Evset" in spec)
apply (drule_tac x="Rep_dom_F (snd TF)" in spec)
apply (simp add: invEv_sub_Evset Rep_dom_F)

apply (rule_tac x="s1 @t [Tick]t" in exI)
apply (simp)

apply (drule_tac x="s1 @t [Tick]t" in spec)
apply (drule_tac x="EvsetTick" in spec)
apply (drule_tac x="<invEv r> EvsetTick" in spec)
apply (drule_tac x="Rep_dom_F (snd TF)" in spec)
apply (simp add: EvsetTick_def Rep_dom_F)
done

(*** F2 ***)

lemma Renamesf_in_F2 : "ALL r TF. TF:dom_SF --> CF2(TF [[r]]sf)"
apply (intro allI impI)
apply (simp add: Renamesf_def CF2_def)
apply (intro allI impI)
apply (simp add: Renamet_in Rep_dom_T Abs_dom_T_inverse)
apply (simp add: Renamef_in Rep_dom_F Abs_dom_F_inverse)

apply (simp add: Renamef_def)
apply (elim conjE exE)
apply (rule_tac x="sa" in exI)
apply (rename_tac r TF s X Y t)
apply (simp)

apply (simp add: dom_SF_def CF2_def)
apply (elim conjE)
apply (drule_tac x="t" in spec)
apply (drule_tac x="<invEv r> X" in spec)
apply (drule_tac x="<invEv r> Y" in spec)

apply (drule mp)
apply (simp)
apply (insert ren_from_notick)
apply (drule_tac x="r" in spec)
apply (drule_tac x="s" in spec)
apply (drule_tac x="t" in spec)
apply (simp)

apply (intro allI impI)
apply (simp add: invrelfun_def)
apply (fold invrelfun_def)
apply (erule bexE)

apply (drule_tac x="b" in spec)
apply (simp)

apply (simp add: Renamet_def)
apply (case_tac "t @t [a]t :t fst TF")

apply (drule_tac x="t @t [a]t" in bspec)
apply (simp)

apply (insert ren_app)
apply (drule_tac x="r" in spec)
apply (drule_tac x="t" in spec)
apply (drule_tac x="[a]t" in spec)
apply (drule_tac x="s" in spec)
apply (drule_tac x="[b]t" in spec)
apply (drule mp)

apply (simp add: trace_app_in_trace_if)
apply (simp add: ren_check_def)
apply (simp add: Abs_trace_inverse event_in_trace)

apply (simp)
apply (simp)
apply (simp add: invrelfun_Un)
done

(*** F3 ***)

lemma Renamesf_in_F3 : "ALL r TF. TF:dom_SF --> CF3(TF [[r]]sf)"
apply (intro allI impI)
apply (simp add: Renamesf_def CF3_def)
apply (intro allI impI)
apply (simp add: Renamet_in Rep_dom_T Abs_dom_T_inverse)
apply (simp add: Renamef_in Rep_dom_F Abs_dom_F_inverse)

apply (erule exE)

apply (simp add: Renamef_def)
apply (elim conjE exE)

apply (simp add: Renamet_def)
apply (rule_tac x="sa" in bexI)
apply (simp)

apply (simp add: dom_SF_def CF3_def)
apply (elim conjE)
apply (drule_tac x="sa" in spec)
apply (drule mp)
apply (rule_tac x="<invEv r> X" in exI)
apply (simp_all)
done

(*** Renamesf in dom_SF ***)

lemma Renamesf_in :
  "ALL r TF. TF:dom_SF --> TF [[r]]sf: dom_SF"
apply (intro allI impI)
apply (simp (no_asm) add: dom_SF_def)
apply (simp add: Renamesf_in_T2)
apply (simp add: Renamesf_in_F2)
apply (simp add: Renamesf_in_F3)
done

(*********************************************************
                     Lemmas (mono)
 *********************************************************)

(*** T ***)

lemma Renamet_mono: 
  "ALL r S T. S <= T --> S [[r]]t <= T [[r]]t"
apply (intro allI impI)
apply (simp add: Renamet_def)
apply (simp add: subset_def)
apply (intro allI impI)
apply (erule bexE)
apply (drule_tac x="s" in bspec)
apply (simp)
apply (rule_tac x="s" in bexI)
apply (simp)
apply (simp)
done

(*** F ***)

lemma Renamef_mono: 
  "ALL r S T. S <= T --> S [[r]]f <= T [[r]]f"
apply (intro allI impI)
apply (simp add: Renamef_def)
apply (simp add: subset_def)
apply (intro allI impI)
apply (elim conjE exE)
apply (drule_tac x="(s, <invEv r> b)" in bspec)
apply (simp)
apply (rule_tac x="s" in exI)
apply (simp)
done

lemma Renamesf_mono: 
  "ALL r SE TF. SE <= TF --> SE [[r]]sf <= TF [[r]]sf"
apply (auto simp add: Renamesf_def)
apply (simp add: order_pair_def)
apply (simp add: subset_T_def subset_F_def)
apply (simp add: Renamet_in Renamef_in Rep_dom_T Rep_dom_F
                 Abs_dom_T_inverse Abs_dom_F_inverse)
apply (simp add: Renamet_mono Renamef_mono)
done

(*********************************************************
                   Rename trace eval
 *********************************************************)

lemma Renamet_eval:
  "ALL r P ev. [[P [[r]]]]T ev = [[P]]T ev [[r]]t"
apply (intro allI)
apply (simp add: eval_T_def)
apply (simp add: eval_TF_decompo)
apply (simp add: Renamesf_def)
apply (simp add: Renamet_in Rep_dom_T Abs_dom_T_inverse)
done

(*********************************************************
                   Rename failure eval
 *********************************************************)

lemma Renamef_eval:
  "ALL r P ev. [[P [[r]]]]F ev = [[P]]F ev [[r]]f"
apply (intro allI)
apply (simp add: eval_F_def)
apply (simp add: eval_TF_decompo)
apply (simp add: Renamesf_def)
apply (simp add: Renamef_in Rep_dom_F Abs_dom_F_inverse)
done

end
