           (*-------------------------------------------*
            |                Csp-Prover                 |
            |               October 2004                |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_cont_Prefix = Csp_Prefix:

(*****************************************************************

         1. a ->sf SF : continuous
         2.
         3. 
         4. 

 *****************************************************************)

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  Union (B ` A) = (UN x:A. B x)                      *)
(*                  Inter (B ` A) = (INT x:A. B x)                     *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare Union_image_eq [simp del]
declare Inter_image_eq [simp del]
declare disj_not1 [simp del]

(*****************************************)

(*** cont ->t ***)

lemma cont_Prefixt:
  "ALL f a. cont f --> cont (%x. Abs_dom_T (a ->t Rep_dom_T (f x)))"
apply (intro allI impI)
apply (rule cont_iffI)
apply (intro allI impI)
apply (elim conjE)
apply (erule lub_cont_funE, simp, simp)
apply (simp add: directed_def lub_to_Union_T)
apply (erule conjE)

apply (rotate_tac -1)
apply (erule rem_asmE)

apply (simp add: dom_T_Union_in_dom_T Prefixt_in Abs_dom_T_inject Rep_dom_T)
apply (rule equalityI)

(* <= *)

apply (rule subsetI)
apply (simp add: Prefixt_in Abs_dom_T_inverse Rep_dom_T)

apply (simp add: Prefixt_def)
apply (erule disjE)
apply (force)

apply (elim conjE exE)
apply (simp add: dom_T_Union_in_dom_T Abs_dom_T_inverse)
apply (elim bexE)

apply (rule_tac x="xb" in bexI)
apply (rule disjI2)
apply (rule_tac x="s" in exI)
apply (simp)
apply (simp)

(* => *)

apply (rule subsetI)
apply (simp add: Prefixt_in Abs_dom_T_inverse Rep_dom_T)
apply (erule bexE)

apply (simp add: Prefixt_def)
apply (erule disjE)
apply (simp)

apply (erule exE)
apply (rule disjI2)
apply (rule_tac x="s" in exI)
apply (simp add: dom_T_Union_in_dom_T Abs_dom_T_inverse)
apply (rule_tac x="xb" in bexI)
apply (simp_all)
done

(*** cont ->f ***)

lemma cont_Prefixf:
  "ALL f a. cont f --> cont (%x. Abs_dom_F (a ->f Rep_dom_F (f x)))"
apply (intro allI impI)
apply (rule cont_iffI)
apply (intro allI impI)
apply (elim conjE)

apply (erule lub_cont_funE, simp, simp)
apply (simp add: lub_to_Union_F)

apply (simp add: dom_F_Union_in_dom_F Prefixf_in Abs_dom_F_inject Rep_dom_F)
apply (rule equalityI)

(* <= *)

apply (rule subsetI)
apply (simp add: Prefixf_in Abs_dom_F_inverse Rep_dom_F)

apply (simp add: Prefixf_def)
apply (erule disjE)
apply (elim conjE exE)

apply (simp add: directed_def)
apply (force)

apply (elim conjE exE)
apply (simp add: dom_F_Union_in_dom_F Abs_dom_F_inverse)
apply (elim bexE)

apply (rule_tac x="xb" in bexI)
apply (rule disjI2)
apply (rule_tac x="s" in exI)
apply (simp)
apply (simp)

(* => *)

apply (rule subsetI)
apply (simp add: Prefixf_in Abs_dom_F_inverse Rep_dom_F)
apply (erule bexE)

apply (simp add: Prefixf_def)
apply (erule disjE)
apply (simp)

apply (elim exE)
apply (rule disjI2)
apply (rule_tac x="s" in exI)
apply (rule_tac x="Xa" in exI)
apply (simp add: dom_F_Union_in_dom_F Abs_dom_F_inverse)
apply (rule_tac x="xb" in bexI)
apply (simp_all)
done

(*** cont ->sf ***)

lemma cont_Prefixsf:
  "ALL f a. cont f --> cont (%x. (a ->sf (f x)))"
apply (intro allI impI)
apply (simp add: Prefixsf_def)
apply (simp add: pair_cont)
apply (simp add: fst_compo_fun snd_compo_fun)

apply (simp add: cont_Prefixt fst_cont comp_def)
apply (simp add: cont_Prefixf snd_cont comp_def)
done

(*** cont [[a -> P]]TF ***)

lemma cont_Prefix_TF:
  "ALL a P. cont [[P]]TF --> cont [[a -> P]]TF"
apply (simp add: cont_Prefixsf)
done

(****************** to add them again ******************)

declare Union_image_eq [simp]
declare Inter_image_eq [simp]
declare disj_not1 [simp]

end
