           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                August 2004                |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_law_IF = Csp_law_basic:

(*****************************************************************

         1. IF-evaluation (split)
         1. IF-True
         1. IF-Flase

 *****************************************************************)

(*********************************************************
                       IF bool
 *********************************************************)

lemma csp_IF_split: 
  "LET df IN IF b THEN P ELSE Q =F[af] LET df IN (if b then P else Q)"
apply (simp add: eqsf_rec_def eval_SF_def)
done

lemmas csp_IF_split_rw_left_eq   = csp_IF_split[THEN csp_rule_rw_left_eq]
lemmas csp_IF_split_rw_left_ref  = csp_IF_split[THEN csp_rule_rw_left_ref]
lemmas csp_IF_split_rw_right_eq  = csp_IF_split[THEN csp_rule_rw_right_eq]
lemmas csp_IF_split_rw_right_ref = csp_IF_split[THEN csp_rule_rw_right_ref]

lemmas csp_IF_split_rw_left      = csp_IF_split_rw_left_eq csp_IF_split_rw_left_ref
lemmas csp_IF_split_rw_right     = csp_IF_split_rw_right_eq csp_IF_split_rw_right_ref

lemmas csp_IF_split_rw           = csp_IF_split_rw_left csp_IF_split_rw_right

(*********************************************************
                       IF True
 *********************************************************)

lemma csp_IF_True:
  "LET df IN IF True THEN P ELSE Q =F[af] LET df IN P"
apply (simp add: eqsf_rec_def eval_SF_def)
done

(*********************************************************
                       IF False
 *********************************************************)

lemma csp_IF_False:
  "LET df IN IF False THEN P ELSE Q =F[af] LET df IN Q"
apply (simp add: eqsf_rec_def eval_SF_def)
done

(*********************************************************
                       IF laws
 *********************************************************)

lemmas csp_IF = csp_IF_True csp_IF_False

lemmas csp_IF_rw_left_eq   = csp_IF[THEN csp_rule_rw_left_eq]
lemmas csp_IF_rw_left_ref  = csp_IF[THEN csp_rule_rw_left_ref]
lemmas csp_IF_rw_right_eq  = csp_IF[THEN csp_rule_rw_right_eq]
lemmas csp_IF_rw_right_ref = csp_IF[THEN csp_rule_rw_right_ref]

lemmas csp_IF_rw_left      = csp_IF_rw_left_eq csp_IF_rw_left_ref
lemmas csp_IF_rw_right     = csp_IF_rw_right_eq csp_IF_rw_right_ref

lemmas csp_IF_rw           = csp_IF_rw_left csp_IF_rw_right

end
