           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_proof_SKIP = Csp_relation_def + Csp_proof_commut + 
                        Csp_proof_decompo:

(*****************************************************************

         1. step laws
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                      SKIP ;; P
 *********************************************************)

(*******************************
         trace part
 *******************************)

(*** trace part (subset) ***)

lemma eq_Sequencet_unit_l_subset: "[[ SKIP ;; P]]T ev <= [[P]]T ev"
apply (simp add: Sequencet_eval)
apply (simp add: Sequencet_def)
apply (rule subsetI)
apply (simp)

 (* rmtick s *)
 apply (erule disjE)
 apply (elim conjE exE)
 apply (simp add: SKIPt_eval)
 apply (simp add: SKIPt_def)
 apply (erule disjE)

  (* t = []t *)
  apply (simp add: rmtick_nil nil_t_in_all_dom eval_T_in)

  (* t = [Tick]t *)
  apply (simp add: rmtick_tick nil_t_in_all_dom eval_T_in)

 (* s @t t *)
 apply (elim conjE exE)
 apply (simp add: SKIPt_eval)
 apply (simp add: SKIPt_def)

  (* []t --> contra *)
  apply (erule disjE)
  apply (simp add: app_t_nil)
  apply (simp add: nil_in_trace event_in_trace Abs_trace_inject)

  apply (insert app_trace_same_last)
  apply (drule_tac x="s" in spec)
  apply (drule_tac x="Tick" in spec)
  apply (drule_tac x="[]t" in spec)
  apply (drule_tac x="Tick" in spec)
  apply (simp add: notick_nil trace_nil_app)
done

(*** trace part (supset) ***)

lemma eq_Sequencet_unit_l_supset: "[[P]]T ev <= [[ SKIP ;; P]]T ev"
apply (simp add: Sequencet_eval)
apply (simp add: Sequencet_def)
apply (rule subsetI)
apply (simp)

apply (rule disjI2)
apply (rule_tac x="[]t" in exI)
apply (rule_tac x="x" in exI)
apply (simp add: notick_nil trace_nil_app)
apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)
done

(*** trace part ***)

lemma eq_Sequencet_unit_l: "[[ SKIP ;; P]]T ev = [[P]]T ev"
apply (rule equalityI)
apply (simp add: eq_Sequencet_unit_l_subset)
apply (simp add: eq_Sequencet_unit_l_supset)
done

(*******************************
         failure part
 *******************************)

(*** failure part (subset) ***)

lemma eq_Sequencef_unit_l_subset: "[[ SKIP ;; P]]F ev <= [[P]]F ev"
apply (simp add: Sequencef_eval)
apply (simp add: Sequencef_def)
apply (rule subsetI)
apply (simp add: pair_fun_apply)

 (* s *)
 apply (erule disjE)
 apply (elim conjE)
 apply (simp add: SKIPf_eval)
 apply (simp add: SKIPf_def)
 apply (erule disjE)

  (* t = []t --> contra *)
  apply (simp add: Evset_def)

  (* t = [Tick]t --> contra *)
  apply (simp add: event_in_trace Abs_trace_inverse)

 (* s @t t *)
 apply (elim conjE exE)
 apply (simp add: SKIPt_eval)
 apply (simp add: SKIPt_def)

  (* []t --> contra *)
  apply (erule disjE)
  apply (simp add: app_t_nil)
  apply (simp add: nil_in_trace event_in_trace Abs_trace_inject)

  apply (insert app_trace_same_last)
  apply (drule_tac x="s" in spec)
  apply (drule_tac x="Tick" in spec)
  apply (drule_tac x="[]t" in spec)
  apply (drule_tac x="Tick" in spec)
  apply (simp add: notick_nil trace_nil_app)
done

(*** failure part (supset) ***)

lemma eq_Sequencef_unit_l_supset:
  "[[P]]F ev <= [[ SKIP ;; P]]F ev"
apply (simp add: Sequencef_eval)
apply (simp add: Sequencef_def)
apply (rule subsetI)
apply (simp)

apply (rule disjI2)
apply (rule_tac x="[]t" in exI)
apply (rule_tac x="fst x" in exI)
apply (rule_tac x="snd x" in exI)

apply (simp add: notick_nil trace_nil_app)
apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)
done

(*** failure part ***)

lemma eq_Sequencef_unit_l:
  "[[ SKIP ;; P]]F ev = [[P]]F ev"
apply (rule equalityI)
apply (simp add: eq_Sequencef_unit_l_subset)
apply (simp add: eq_Sequencef_unit_l_supset)
done

(*** proc ***)

lemma eq_Sequence_unit_l: "SKIP ;; P =F<ev> P"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Sequencet_unit_l)
apply (simp add: eq_Sequencef_unit_l)
done

(*********************************************************
                      P ;; SKIP
 *********************************************************)

(*******************************
         trace part
 *******************************)

(*** trace part (subset) ***)

lemma eq_Sequencet_unit_r_subset:
  "[[ P ;; SKIP ]]T ev <= [[P]]T ev"
apply (simp add: Sequencet_eval)
apply (simp add: Sequencet_def)
apply (rule subsetI)
apply (simp)

 (* rmtick s *)
 apply (erule disjE)
 apply (elim conjE exE)
 apply (insert dom_T_is_prefix_closed)
 apply (drule_tac x="rmtick s" in spec)
 apply (drule_tac x="s" in spec)
 apply (drule_tac x="[[P]]T ev" in spec)
 apply (simp add: eval_T_in rmtick_is_prefix)

 (* s @t t *)
 apply (elim conjE exE)
 apply (simp add: SKIPt_eval)
 apply (simp add: SKIPt_def)

  (* []t *)
  apply (erule disjE)
  apply (simp add: trace_app_nil)

  apply (drule_tac x="s" in spec)
  apply (drule_tac x="s @t [Tick]t" in spec)
  apply (drule_tac x="[[P]]T ev" in spec)
  apply (simp add: eval_T_in prefix_app)

  (* [Ticl]t *)
  apply (drule_tac x="s" in spec) (* dummy *)
  apply (simp)
done

(*** trace part (supset) ***)

lemma eq_Sequencet_unit_r_supset:
  "[[P]]T ev <= [[ P ;; SKIP]]T ev"
apply (simp add: Sequencet_eval)
apply (simp add: Sequencet_def)
apply (rule subsetI)
apply (simp)

apply (insert rmtick_trace)
apply (drule_tac x="x" in spec)

 (* rmtick s *)
 apply (erule disjE)
 apply (rule disjI1)
 apply (rule_tac x="x" in exI)
 apply (simp)

 (* rmtick x @t [Tick]t *)
 apply (rule disjI2)
 apply (rule_tac x="rmtick x" in exI)
 apply (rule_tac x="[Tick]t" in exI)
 apply (simp add: rmtick_is_notick)
 apply (simp add: SKIPt_eval)
 apply (simp add: SKIPt_def)
done

(*** trace part ***)

lemma eq_Sequencet_unit_r:
  "[[ P ;; SKIP]]T ev = [[P]]T ev"
apply (rule equalityI)
apply (simp add: eq_Sequencet_unit_r_subset)
apply (simp add: eq_Sequencet_unit_r_supset)
done

(*******************************
         failure part
 *******************************)

(*** failure part (subset) ***)

lemma eq_Sequencef_unit_r_subset:
  "[[ P ;; SKIP]]F ev <= [[P]]F ev"
apply (simp add: Sequencef_eval)
apply (simp add: Sequencef_def)
apply (rule subsetI)
apply (simp add: pair_fun_apply)

 (* s *)
 apply (erule disjE)
 apply (insert eval_F_in)
 apply (drule_tac x="P" in spec)
 apply (drule_tac x="ev" in spec)
 apply (simp add: dom_F_def)
 apply (unfold CF1_def)
 apply (drule_tac x="fst x" in spec)
 apply (drule_tac x="insert Tick (snd x)" in spec)
 apply (drule_tac x="snd x" in spec)
 apply (drule mp)
 apply (force)
 apply (simp)

 (* s @t t *)
 apply (drule_tac x="P" in spec)   (* dummy *)
 apply (drule_tac x="ev" in spec)  (* dummy *)
 apply (elim conjE exE)

 apply (simp add: SKIPf_eval)
 apply (simp add: SKIPf_def)

 apply (insert T2_F1_Evset)
 apply (drule_tac x="s" in spec)
 apply (drule_tac x="P" in spec)
 apply (drule_tac x="X" in spec)
 apply (drule_tac x="ev" in spec)
 apply (erule disjE)

 (* []t *)
  apply (simp add: trace_app_nil)

 (* [Tick]t *)

  apply (insert T2_F1_EvsetTick)
  apply (drule_tac x="s" in spec)
  apply (drule_tac x="P" in spec)
  apply (drule_tac x="X" in spec)
  apply (drule_tac x="ev" in spec)
  apply (simp)
done

(*** failure part (supset) ***)

lemma eq_Sequencef_unit_r_supset:
  "[[P]]F ev <= [[ P ;; SKIP]]F ev"
apply (simp add: Sequencef_eval)
apply (simp add: Sequencef_def)
apply (rule subsetI)
apply (simp add: pair_fun_apply)

apply (insert rmtick_trace)
apply (drule_tac x="fst x" in spec)
apply (erule disjE)

 (* rmtick s *)
 apply (insert rmtick_is_notick)
 apply (drule_tac x="fst x" in spec)
 apply (simp)

 apply (case_tac "Tick : snd x")
  apply (rule disjI1)
  apply (subgoal_tac "insert Tick (snd x) = snd x")
  apply (simp)
  apply (force)

  (* Tick ~: snd x *)
  apply (case_tac "((fst x) @t [Tick]t : [[P]]T ev)")

   apply (rule disjI2)
   apply (rule_tac x="fst x" in exI)
   apply (rule_tac x="[]t" in exI)
   apply (rule_tac x="snd x" in exI)
   apply (simp add: trace_app_nil)
   apply (simp add: SKIPf_eval)
   apply (simp add: SKIPf_def)
   apply (simp add: Evset_def)
   apply (force)

   (* (fst x) @t [Tick]t ~: [[P]]T ev *)
   apply (rule disjI1)
   apply (insert procsf_in)
   apply (drule_tac x="P" in spec)
   apply (drule_tac x="ev" in spec)

   apply (simp add: eval_TF_decompo)
   apply (simp add: dom_SF_def)
   apply (simp add: CF2_def)

   apply (erule conjE)+
   apply (drule_tac x="fst x" in spec)
   apply (drule_tac x="snd x" in spec)
   apply (drule_tac x="{Tick}" in spec)
   apply (simp add: Abs_dom_T_inverse eval_T_in)
   apply (simp add: Abs_dom_F_inverse eval_F_in)

 (* rmtick x @t [Tick]t *)
 apply (rule disjI2)
 apply (rule_tac x="rmtick (fst x)" in exI)
 apply (rule_tac x="[Tick]t" in exI)
 apply (rule_tac x="snd x" in exI)
 apply (simp add: rmtick_is_notick)
 apply (simp add: SKIPf_eval)
 apply (simp add: SKIPf_def)
 apply (simp add: EvsetTick_def)

 apply (drule_tac x="P" in spec)
 apply (drule_tac x="ev" in spec)

 apply (simp add: eval_TF_decompo)
 apply (simp add: dom_SF_def)
 apply (simp add: CF3_def)

 apply (erule conjE)+
 apply (drule_tac x="fst x" in spec)
 apply (simp add: Abs_dom_T_inverse eval_T_in)
 apply (simp add: Abs_dom_F_inverse eval_F_in)
 apply (drule mp)
  apply (rule_tac x="snd x" in exI, simp)
 apply (simp)
done

(*** failure part ***)

lemma eq_Sequencef_unit_r:
  "[[ P ;; SKIP]]F ev = [[P]]F ev"
apply (rule equalityI)
apply (simp add: eq_Sequencef_unit_r_subset)
apply (simp add: eq_Sequencef_unit_r_supset)
done

(*** proc ***)

lemma eq_Sequence_unit_r: "P ;; SKIP =F<ev> P"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Sequencet_unit_r)
apply (simp add: eq_Sequencef_unit_r)
done

(*********************************************************
                      SKIP |[X]| P
 *********************************************************)

(*******************************
         trace part
 *******************************)

(*** lm 1 ***)

lemma eq_Parallelt_preterm_l_subset_lm1:
  "[| x : []t |[X]|set t; t : [[? :Y -> Pf]]T ev |]
   ==> x : [[? x:(Y - X) -> (SKIP |[X]| Pf x)]]T ev"
apply (simp add: Pre_choicet_eval)

 (* t=[]t *)
 apply (erule disjE)
 apply (simp add: par_trace_nil_nil_to_nil)

 (* t = [Ev a]t @t s *)
 apply (elim conjE exE)
 apply (rule disjI2)

 apply (insert par_trace_head_nil_Ev_app)
 apply (drule_tac x="X" in spec)
 apply (drule_tac x="x" in spec)
 apply (drule_tac x="a" in spec)
 apply (drule_tac x="s" in spec)
 apply (simp)
 apply (elim conjE exE)

 apply (rule_tac x="a" in exI)
 apply (rule_tac x="v" in exI)
 apply (simp)

 apply (simp add: Parallelt_eval)
 apply (simp add: Parallelt_def)
 apply (rule_tac x="[]t |[X]|set s" in exI)
 apply (simp)
 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="s" in exI)
 apply (simp add: eval_T_in nil_t_in_all_dom)
done

(*** lm 2 ***)

lemma eq_Parallelt_preterm_l_subset_lm2:
  "[| x : [Tick]t |[X]|set t; t : [[? :Y -> Pf]]T ev |]
       ==> x : [[? x:(Y - X) -> (SKIP |[X]| Pf x)]]T ev"
apply (simp add: Pre_choicet_eval)

 (* t=[]t *)
 apply (erule disjE)
 apply (simp add: par_trace_Tick_nil)

 (* t = [Ev a]t @t s *)
 apply (elim conjE exE)
 apply (rule disjI2)

 apply (insert par_trace_head_Tick_Ev_app)
 apply (drule_tac x="X" in spec)
 apply (drule_tac x="x" in spec)
 apply (drule_tac x="a" in spec)
 apply (drule_tac x="s" in spec)
 apply (simp)
 apply (elim conjE exE)

 apply (rule_tac x="a" in exI)
 apply (rule_tac x="v" in exI)
 apply (simp)

 apply (simp add: Parallelt_eval)
 apply (simp add: Parallelt_def)
 apply (rule_tac x="[Tick]t |[X]|set s" in exI)
 apply (simp)
 apply (rule_tac x="[Tick]t" in exI)
 apply (rule_tac x="s" in exI)
 apply (simp add: SKIPt_eval)
 apply (simp add: SKIPt_def)
done

(*** trace part (subset) ***)

lemma eq_Parallelt_preterm_l_subset: 
  "[[SKIP |[X]| ? :Y -> Pf]]T ev <=
   [[? x:(Y-X) -> (SKIP |[X]| Pf x)]]T ev"
apply (simp add: Parallelt_eval)
apply (simp add: Parallelt_def)
apply (rule subsetI)
apply (simp)
apply (elim conjE exE)

apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)

 (* s=[]t *)
 apply (erule disjE)
 apply (simp add: eq_Parallelt_preterm_l_subset_lm1)

 (* s = [Tick]t *)
 apply (simp add: eq_Parallelt_preterm_l_subset_lm2)
done

(*** trace part (supset) ***)

lemma eq_Parallelt_preterm_l_supset: 
  "[[? x:(Y-X) -> (SKIP |[X]| Pf x)]]T ev <=
   [[SKIP |[X]| ? :Y -> Pf]]T ev"
apply (simp add: Parallelt_eval)
apply (simp add: Parallelt_def)
apply (rule subsetI)

apply (simp add: Pre_choicet_eval)
apply (erule disjE)

  (* []t *)
 apply (rule_tac x="[]t |[X]|set []t" in exI)
 apply (simp add: par_trace_nil)

 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="[]t" in exI)
 apply (simp add: eval_T_in nil_t_in_all_dom)

  (* [Ev a]t @t s *)
 apply (elim conjE exE)
 apply (simp add: Parallelt_eval)
 apply (simp add: Parallelt_def)
 apply (elim conjE exE)
 apply (simp)

 apply (rule_tac x="sa |[X]|set ([Ev a]t @t t)" in exI)
 apply (rule conjI)

  (* conj 1 *)
  apply (rule_tac x="sa" in exI)
  apply (rule_tac x="[Ev a]t @t t" in exI)
  apply (simp)

  apply (rule disjI2)
  apply (rule_tac x="a" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp)

  (* conj 2 *)
  apply (insert par_trace_head_if)
  apply (drule_tac x="X" in spec)
  apply (drule_tac x="Ev a" in spec)
  apply (drule_tac x="s" in spec)
  apply (drule_tac x="sa" in spec)
  apply (drule_tac x="[Ev a]t @t t" in spec)
  apply (drule mp)

   apply (rule disjI2)
   apply (rule conjI)
    apply (simp add: image_iff)

   apply (rule disjI2)
   apply (rule_tac x="t" in exI)
   apply (simp add: trace_event_app_in_trace)
  apply (simp)
done

(*** trace part ***)

lemma eq_Parallelt_preterm_l:
  "[[SKIP |[X]| ? :Y -> Pf]]T ev =
   [[? x:(Y-X) -> (SKIP |[X]| Pf x)]]T ev"
apply (rule equalityI)
apply (simp add: eq_Parallelt_preterm_l_subset)
apply (simp add: eq_Parallelt_preterm_l_supset)
done

(*******************************
         failure part
 *******************************)

(*** lemmas for sets ***)

lemma eq_Parallelf_preterm_l_subset_set1:
     "[| Z1 - insert Tick (Ev ` X) = Z2 - insert Tick (Ev ` X);
          Ev ` Y Int Z2 = {} |]
       ==> Ev ` (Y - X) Int (Z1 Un Z2) = {}"
apply (auto)
done

(*** lemma 1 ***)

lemma eq_Parallelf_preterm_l_subset_lm1:
  "[| Z1 - insert Tick (Ev ` X) = Z2 - insert Tick (Ev ` X);
      u : []t |[X]|set t; (t, Z2) : [[? :Y -> Pf]]F ev; Z1 <= Evset |]
       ==> (u, Z1 Un Z2) : [[? x:(Y - X) -> (SKIP |[X]| Pf x)]]F ev"
apply (simp add: Pre_choicef_eval)

 (* t=[]t *)
 apply (erule disjE)
 apply (elim conjE exE)
 apply (simp add: par_trace_nil_nil_to_nil)
 apply (simp add: eq_Parallelf_preterm_l_subset_set1)

 (* t = [Ev a]t @t sa *)
 apply (elim conjE exE)
 apply (rule disjI2)
 apply (simp)

 apply (insert par_trace_head_nil_Ev_app)
 apply (drule_tac x="X" in spec)
 apply (drule_tac x="u" in spec)
 apply (drule_tac x="a" in spec)
 apply (drule_tac x="s" in spec)
 apply (simp)
 apply (elim conjE exE)

 apply (rule_tac x="a" in exI)
 apply (rule_tac x="v" in exI)

 apply (simp add: Parallelf_eval)
 apply (simp add: Parallelf_def)
 apply (rule_tac x="Z1" in exI)
 apply (rule_tac x="Z2" in exI)
 apply (simp)

 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="s" in exI)
 apply (simp add: SKIPf_eval)
 apply (simp add: SKIPf_def)
done

(*** lemma 2 ***)

lemma eq_Parallelf_preterm_l_subset_lm2:
  "[| Z1 - insert Tick (Ev ` X) = Z2 - insert Tick (Ev ` X);
          u : [Tick]t |[X]|set t; (t, Z2) : [[? :Y -> Pf]]F ev;
          Z1 <= EvsetTick |]
       ==> (u, Z1 Un Z2) : [[? x:(Y - X) -> (SKIP |[X]| Pf x)]]F ev"
apply (simp add: Pre_choicef_eval)

 (* t=[]t *)
 apply (erule disjE)
 apply (simp add: par_trace_Tick_nil)

 (* t = [Ev a]t @t sa *)
 apply (elim conjE exE)
 apply (rule disjI2)
 apply (simp)

 apply (insert par_trace_head_Tick_Ev_app)
 apply (drule_tac x="X" in spec)
 apply (drule_tac x="u" in spec)
 apply (drule_tac x="a" in spec)
 apply (drule_tac x="s" in spec)
 apply (simp)
 apply (elim conjE exE)

 apply (rule_tac x="a" in exI)
 apply (rule_tac x="v" in exI)

 apply (simp add: Parallelf_eval)
 apply (simp add: Parallelf_def)
 apply (rule_tac x="Z1" in exI)
 apply (rule_tac x="Z2" in exI)
 apply (simp)

 apply (rule_tac x="[Tick]t" in exI)
 apply (rule_tac x="s" in exI)
 apply (simp add: SKIPf_eval)
 apply (simp add: SKIPf_def)
done

(*** failure part (subset) ***)

lemma eq_Parallelf_preterm_l_subset: 
  "[[SKIP |[X]| ? :Y -> Pf]]F ev <=
   [[? x:(Y-X) -> (SKIP |[X]| Pf x)]]F ev"
apply (simp add: Parallelf_eval)
apply (simp add: Parallelf_def)
apply (rule subsetI)
apply (simp)
apply (elim conjE exE)

apply (simp add: SKIPf_eval)
apply (simp add: SKIPf_def)

 (* s = []t & Z1 <= Evset *)
 apply (erule disjE)
 apply (simp add: eq_Parallelf_preterm_l_subset_lm1)

 (* s = [Tick]t & Z1 <= EvsetTick *)
 apply (simp add: eq_Parallelf_preterm_l_subset_lm2)
done

(*** failure part (supset) ***)

lemma eq_Parallelf_preterm_l_supset: 
  "[[? x:(Y-X) -> (SKIP |[X]| Pf x)]]F ev <=
   [[SKIP |[X]| ? :Y -> Pf]]F ev"
apply (simp add: Parallelf_eval)
apply (simp add: Parallelf_def)
apply (rule subsetI)

apply (simp add: Pre_choicef_eval)
apply (erule disjE)

  (* []t *)
 apply (elim conjE exE)
 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="Ya - {Tick}" in exI)
 apply (rule_tac x="Ya - (Ev ` X)" in exI)
 apply (simp)
 apply (rule conjI, force)
 apply (rule conjI, force)

 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="[]t" in exI)
 apply (simp add: par_trace_nil_nil)

 apply (simp add: SKIPf_eval)
 apply (simp add: SKIPf_def)
 apply (rule conjI, simp add: Evset_def, force)

 apply (rule disjI1, force)

  (* [Ev a]t @t s *)
 apply (elim conjE exE)
 apply (simp add: Parallelf_eval)
 apply (simp add: Parallelf_def)
 apply (elim conjE exE)
 apply (rename_tac x a s Z12 Z1 Z2 s1 s2)

 apply (rule_tac x="Z1" in exI)
 apply (rule_tac x="Z2" in exI)
 apply (simp)

 apply (rule_tac x="s1" in exI)
 apply (rule_tac x="[Ev a]t @t s2" in exI)
 apply (simp)

 apply (insert par_trace_head_if)
 apply (drule_tac x="X" in spec)
 apply (drule_tac x="Ev a" in spec)
 apply (drule_tac x="s" in spec)
 apply (drule_tac x="s1" in spec)
 apply (drule_tac x="[Ev a]t @t s2" in spec)
 apply (drule mp)

  apply (rule disjI2)
  apply (rule conjI)
  apply (simp add: image_iff)
  apply (rule disjI2)
  apply (rule_tac x="s2" in exI)
  apply (simp add: trace_event_app_in_trace)

 apply (simp)
 apply (rule disjI2)
 apply (rule_tac x="a" in exI)
 apply (rule_tac x="s2" in exI)
 apply (simp)
done

(*** faiure part ***)

lemma eq_Parallelf_preterm_l:
  "[[SKIP |[X]| ? :Y -> Pf]]F ev =
   [[? x:(Y-X) -> (SKIP |[X]| Pf x)]]F ev"
apply (rule equalityI)
apply (simp add: eq_Parallelf_preterm_l_subset)
apply (simp add: eq_Parallelf_preterm_l_supset)
done

(*** proc ***)

lemma eq_Parallel_preterm_l:
  "SKIP |[X]| ? :Y -> Pf =F<ev> ? x:(Y-X) -> (SKIP |[X]| Pf x)"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Parallelt_preterm_l)
apply (simp add: eq_Parallelf_preterm_l)
done

(*********************************************************
                      P |[X]| SKIP
 *********************************************************)

lemma eq_Parallel_preterm_r:
  "? :Y -> Pf |[X]| SKIP =F<ev> ? x:(Y-X) -> (Pf x |[X]| SKIP)"
apply (rule eqsf_trans)
apply (rule eq_Parallel_commut)
apply (rule eqsf_trans)
apply (rule eq_Parallel_preterm_l)
apply (rule eq_Pre_choice_cong)
apply (rule eq_Parallel_commut)
done

(*********************************************************
                   SKIP |[X]| SKIP
 *********************************************************)

(*******************************
         trace part
 *******************************)

(*** trace part (subset) ***)

lemma eq_Parallelt_term_subset: 
  "[[SKIP |[X]| SKIP]]T ev <= [[SKIP]]T ev"
apply (simp add: Parallelt_eval)
apply (simp add: Parallelt_def)
apply (rule subsetI)
apply (simp)
apply (elim conjE exE)
apply (rename_tac u st s t)

apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)

 (* s=[]t *)
 apply (erule disjE)
  (* t=[]t *)
  apply (erule disjE)
  apply (simp add: par_trace_nil_nil_to_nil)

  (* t=[Tick]t *)
  apply (simp add: par_trace_nil_Tick)

 (* s=[Tick]t *)

  (* t=[]t *)
  apply (erule disjE)
  apply (simp add: par_trace_Tick_nil)

  (* t=[Tick]t *)
  apply (simp add: par_trace_Tick_Tick_to_Tick)
done

(*** trace part (supset) ***)

lemma eq_Parallelt_term_supset: 
  "[[SKIP]]T ev <= [[SKIP |[X]| SKIP]]T ev"
apply (simp add: Parallelt_eval)
apply (simp add: Parallelt_def)
apply (rule subsetI)

apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)

 (* x=[]t *)
 apply (erule disjE)
 apply (rule_tac x="[]t |[X]|set []t" in exI)
 apply (simp add: par_trace_nil_nil)
 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="[]t" in exI)
 apply (simp)

 (* x=[Tick]t *)
 apply (rule_tac x="[Tick]t |[X]|set [Tick]t" in exI)
 apply (simp add: par_trace_Tick_if)
 apply (rule_tac x="[Tick]t" in exI)
 apply (rule_tac x="[Tick]t" in exI)
 apply (simp)
done

(*** trace part ***)

lemma eq_Parallelt_term: 
  "[[SKIP |[X]| SKIP]]T ev = [[SKIP]]T ev"
apply (rule equalityI)
apply (simp add: eq_Parallelt_term_subset)
apply (simp add: eq_Parallelt_term_supset)
done

(*******************************
         failure part
 *******************************)

(*** failure part (subset) ***)

lemma eq_Parallelf_term_subset: 
  "[[SKIP |[X]| SKIP]]F ev <= [[SKIP]]F ev"
apply (simp add: Parallelf_eval)
apply (simp add: Parallelf_def)
apply (rule subsetI)
apply (simp)
apply (elim conjE exE)

apply (simp add: SKIPf_eval)
apply (simp add: SKIPf_def)

 (* s=[]t *)
 apply (erule disjE)
  (* t=[]t *)
  apply (erule disjE)
  apply (simp add: par_trace_nil_nil_to_nil)
  apply (force)

  (* t=[Tick]t *)

  apply (simp add: par_trace_nil_Tick)

 (* s=[Tick]t *)

  (* t=[]t *)
  apply (erule disjE)
  apply (simp add: par_trace_Tick_nil)

  (* t=[Tick]t *)
  apply (simp add: par_trace_Tick_Tick_to_Tick)
  apply (force)
done

(*** failure part (supset) ***)

lemma eq_Parallelf_term_supset: 
  "[[SKIP]]F ev <= [[SKIP |[X]| SKIP]]F ev"
apply (simp add: Parallelf_eval)
apply (simp add: Parallelf_def)
apply (rule subsetI)

apply (simp add: SKIPf_eval)
apply (simp add: SKIPf_def)

 (* []t *)
 apply (erule disjE)
 apply (elim conjE exE)
 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="Xa" in exI)
 apply (rule_tac x="Xa" in exI)
 apply (simp)
 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="[]t" in exI)
 apply (simp add: par_trace_nil_nil)

 (* x=[Tick]t *)
 apply (elim conjE exE)
 apply (rule_tac x="[Tick]t" in exI)
 apply (rule_tac x="Xa" in exI)
 apply (rule_tac x="Xa" in exI)
 apply (simp)
 apply (rule_tac x="[Tick]t" in exI)
 apply (rule_tac x="[Tick]t" in exI)
 apply (simp add: par_trace_Tick_if)
done

(*** failure part ***)

lemma eq_Parallelf_term: 
  "[[SKIP |[X]| SKIP]]F ev = [[SKIP]]F ev"
apply (rule equalityI)
apply (simp add: eq_Parallelf_term_subset)
apply (simp add: eq_Parallelf_term_supset)
done

(*** proc ***)

lemma eq_Parallel_term:
  "SKIP |[X]| SKIP =F<ev> SKIP"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Parallelt_term)
apply (simp add: eq_Parallelf_term)
done

(*********************************************************
                   SKIP -- X
 *********************************************************)

(*******************************
         trace part
 *******************************)

(*** trace part (subset) ***)

lemma eq_SKIP_Hidet_Id_subset: 
  "[[SKIP -- X]]T ev <= [[SKIP]]T ev"
apply (simp add: Hidet_eval)
apply (simp add: Hidet_def)
apply (rule subsetI)
apply (simp)
apply (elim conjE exE)

apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)

 (* []t *)
 apply (erule disjE)
 apply (simp add: hide_trace_nil)

 (* [Tick]t *)
 apply (simp add: hide_trace_Tick)
done

(*** trace part (supset) ***)

lemma eq_SKIP_Hidet_Id_supset: 
  "[[SKIP]]T ev <= [[SKIP -- X]]T ev"
apply (simp add: Hidet_eval)
apply (simp add: Hidet_def)
apply (rule subsetI)

apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)

 (* x=[]t *)
 apply (erule disjE)
 apply (rule_tac x="[]t" in exI)
 apply (simp add: hide_trace_nil)

 (* x=[Tick]t *)
 apply (rule_tac x="[Tick]t" in exI)
 apply (simp add: hide_trace_Tick)
done

(*** trace part ***)

lemma eq_SKIP_Hidet_Id: 
  "[[SKIP -- X]]T ev = [[SKIP]]T ev"
apply (rule equalityI)
apply (simp add: eq_SKIP_Hidet_Id_subset)
apply (simp add: eq_SKIP_Hidet_Id_supset)
done

(*******************************
         failure part
 *******************************)

(*** failure part (subset) ***)

lemma eq_SKIP_Hidef_Id_subset: 
  "[[SKIP -- X]]F ev <= [[SKIP]]F ev"
apply (simp add: Hidef_eval)
apply (simp add: Hidef_def)
apply (rule subsetI)
apply (simp)
apply (elim conjE exE)

apply (simp add: SKIPf_eval)
apply (simp add: SKIPf_def)

 (* []t *)
 apply (erule disjE)
 apply (simp add: hide_trace_nil)
 apply (force)

 (* [Tick]t *)
 apply (simp add: hide_trace_Tick)
 apply (force)
done

(*** failure part (supset) ***)

lemma eq_SKIP_Hidef_Id_supset: 
  "[[SKIP]]F ev <= [[SKIP -- X]]F ev"
apply (simp add: Hidef_eval)
apply (simp add: Hidef_def)
apply (rule subsetI)

apply (simp add: SKIPf_eval)
apply (simp add: SKIPf_def)

 (* []t *)
 apply (erule disjE)
 apply (elim conjE exE)
 apply (rule_tac x="[]t" in exI)
 apply (rule_tac x="Xa" in exI)
 apply (simp add: hide_trace_nil)
 apply (simp add: Evset_def)
 apply (force)

 (* x=[Tick]t *)
 apply (elim conjE exE)
 apply (rule_tac x="[Tick]t" in exI)
 apply (rule_tac x="Xa" in exI)
 apply (simp add: hide_trace_Tick)
 apply (simp add: EvsetTick_def)
done

(*** failure part ***)

lemma eq_SKIP_Hidef_Id: 
  "[[SKIP -- X]]F ev = [[SKIP]]F ev"
apply (rule equalityI)
apply (simp add: eq_SKIP_Hidef_Id_subset)
apply (simp add: eq_SKIP_Hidef_Id_supset)
done

(*** proc ***)

lemma eq_SKIP_Hide_Id:
  "SKIP -- X =F<ev> SKIP"
apply (simp add: eqsf_decompo)
apply (simp add: eq_SKIP_Hidet_Id)
apply (simp add: eq_SKIP_Hidef_Id)
done

(*********************************************************
                   SKIP [[r]]
 *********************************************************)

(*******************************
         trace part
 *******************************)

(*** trace part (subset) ***)

lemma eq_SKIP_Renamet_Id_subset: 
  "[[SKIP [[r]]]]T ev <= [[SKIP]]T ev"
apply (simp add: Renamet_eval)
apply (simp add: Renamet_def)
apply (rule subsetI)
apply (simp)
apply (elim bexE)

apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)

 (* []t *)
 apply (erule disjE)
 apply (simp add: ren_to_nil)

 (* [Tick]t *)
 apply (simp add: ren_to_tick)
done

(*** trace part (supset) ***)

lemma eq_SKIP_Renamet_Id_supset: 
  "[[SKIP]]T ev <= [[SKIP [[r]]]]T ev"
apply (simp add: Renamet_eval)
apply (simp add: Renamet_def)
apply (rule subsetI)

apply (simp add: SKIPt_eval)
apply (simp add: SKIPt_def)

 (* x=[]t *)
 apply (erule disjE)
 apply (simp add: ren_nil)

 (* x=[Tick]t *)
 apply (simp add: ren_tick)
done

(*** trace part ***)

lemma eq_SKIP_Renamet_Id: 
  "[[SKIP [[r]]]]T ev = [[SKIP]]T ev"
apply (rule equalityI)
apply (simp add: eq_SKIP_Renamet_Id_subset)
apply (simp add: eq_SKIP_Renamet_Id_supset)
done

(*******************************
         failure part
 *******************************)

(*** failure part (subset) ***)

lemma eq_SKIP_Renamef_Id_subset: 
  "[[SKIP [[r]]]]F ev <= [[SKIP]]F ev"
apply (simp add: Renamef_eval)
apply (simp add: Renamef_def)
apply (rule subsetI)
apply (simp add: pair_fun_apply)
apply (elim conjE exE)

apply (simp add: SKIPf_eval)
apply (simp add: SKIPf_def)

 (* []t *)
 apply (erule disjE)
 apply (rule disjI1)
 apply (rule_tac x="snd x" in exI)
 apply (simp add: invEv_sub_X_Evset)
 apply (simp add: eq_pair_decompo ren_to_nil)

 (* [Tick]t *)
 apply (rule disjI2)
 apply (rule_tac x="snd x" in exI)
 apply (simp add: eq_pair_decompo ren_to_tick)
 apply (simp add: EvsetTick_def)
done

(*** failure part (supset) ***)

lemma eq_SKIP_Renamef_Id_supset: 
  "[[SKIP]]F ev <= [[SKIP [[r]]]]F ev"
apply (simp add: Renamef_eval)
apply (simp add: Renamef_def)
apply (rule subsetI)

apply (simp add: SKIPf_eval pair_fun_apply)
apply (simp add: SKIPf_def)

 (* []t *)
 apply (erule disjE)
 apply (elim conjE exE)
 apply (rule_tac x="[]t" in exI)
 apply (simp add: ren_nil)
 apply (simp add: invEv_sub_X_Evset)

 (* x=[Tick]t *)
 apply (elim conjE exE)
 apply (rule_tac x="[Tick]t" in exI)
 apply (simp add: ren_tick)
 apply (simp add: EvsetTick_def)
done

(*** failure part ***)

lemma eq_SKIP_Renamef_Id: 
  "[[SKIP [[r]]]]F ev = [[SKIP]]F ev"
apply (rule equalityI)
apply (simp add: eq_SKIP_Renamef_Id_subset)
apply (simp add: eq_SKIP_Renamef_Id_supset)
done

(*** proc ***)

lemma eq_SKIP_Rename_Id: "SKIP [[r]] =F<ev> SKIP"
apply (simp add: eqsf_decompo)
apply (simp add: eq_SKIP_Renamet_Id)
apply (simp add: eq_SKIP_Renamef_Id)
done

end
