           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_proof_commut = Csp_relation_def:

(*****************************************************************

         1. Commutativity
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                      Ext choice
 *********************************************************)

lemma eq_Ext_choice_commut:
  "P [+] Q =F<ev> Q [+] P"
apply (simp add: eqsf_decompo)
apply (simp add: Ext_choicet_eval)
apply (simp add: Ext_choicef_eval)
apply (auto)
done

(*********************************************************
                      Int choice
 *********************************************************)

lemma eq_Int_choice_commut:
  "P |~| Q =F<ev> Q |~| P"
apply (simp add: eqsf_decompo)
apply (simp add: Int_choicet_eval)
apply (simp add: Int_choicef_eval)
apply (auto)
done

(*********************************************************
                      Parallel
 *********************************************************)

(*** trace part ***)

lemma eq_Parallelt_commut_sub:
  "[[P]]T ev |[X]|t [[Q]]T ev <= [[Q]]T ev |[X]|t [[P]]T ev"
apply (simp add: Parallelt_def)
apply (simp add: subset_def)
apply (intro allI impI ballI)
apply (elim conjE exE)

apply (rule_tac x="s |[X]|set t" in exI)
apply (simp)
apply (rule_tac x="t" in exI)
apply (rule_tac x="s" in exI)
apply (simp add: par_trace_sym)
done

(*** failure part ***)

lemma eq_Parallelf_commut_sub:
  "[[P]]F ev |[X]|f [[Q]]F ev <= [[Q]]F ev |[X]|f [[P]]F ev"
apply (simp add: Parallelf_def)
apply (simp add: subset_def)
apply (intro allI impI)
apply (elim conjE exE)

apply (rule_tac x="Z" in exI)
apply (rule_tac x="Y" in exI)
apply (simp add: Un_def)
apply (rule conjI)
apply (blast)

apply (rule_tac x="t" in exI)
apply (rule_tac x="s" in exI)
apply (simp add: par_trace_sym)
done

(*** proc ***)

lemma eq_Parallel_commut: "P |[X]| Q =F<ev> Q |[X]| P"
apply (simp add: eqsf_decompo)
apply (simp add: Parallelt_eval)
apply (simp add: Parallelf_eval)
apply (rule conjI)
apply (rule equalityI)
apply (simp add: eq_Parallelt_commut_sub)
apply (simp add: eq_Parallelt_commut_sub)
apply (rule equalityI)
apply (simp add: eq_Parallelf_commut_sub)
apply (simp add: eq_Parallelf_commut_sub)
done

end
