           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_proof_dist1 = Csp_relation_def +
                         Csp_proof_commut + Csp_proof_decompo:

(*****************************************************************

         1. Int choice distribution
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
        Int choice distribution over Prefix choice
 *********************************************************)

lemma eq_Pre_choice_dist: 
  "? x:X -> (P |~| Q) =F<ev>
  (? x:X -> P) |~| (? x:X -> Q)"
apply (simp add: eqsf_decompo)

apply (simp add: Int_choicet_eval)
apply (simp add: Pre_choicet_eval)
apply (simp add: Int_choicet_eval)

apply (simp add: Int_choicef_eval)
apply (simp add: Pre_choicef_eval)
apply (simp add: Int_choicef_eval)
apply (auto)
done

(*********************************************************
        Int bind distribution over Prefix choice
 *********************************************************)

(*** trace part ***)

lemma eq_Pre_choicet_Dist:
  "Y ~= {} ==>
       [[? x:X -> (! y:Y .. P)]]T ev =
       [[! y:Y .. (? x:X -> P)]]T ev"
apply (simp add: Int_bindt_eval)
apply (simp add: Pre_choicet_eval)
apply (simp add: Int_bindt_eval)
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (elim conjE exE)
apply (rule disjI2)
apply (erule nonempty_exE)
apply (simp)
apply (rule disjI2)
apply (erule disjE)
apply (rule_tac x="a" in exI)
apply (rule_tac x="[]t" in exI)
apply (simp add: eval_T_in nil_t_in_all_dom)
apply (rule_tac x="a" in exI)
apply (rule_tac x="s" in exI)
apply (simp)

      (* => *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (elim conjE exE)
apply (erule disjE)
apply (simp)

apply (elim conjE exE)
apply (rule disjI2)
apply (rule_tac x="aa" in exI)
apply (rule_tac x="s" in exI)
apply (simp)
done

(*** failure part ***)

lemma eq_Pre_choicef_Dist:
  "Y ~= {} ==>
       [[? x:X -> (! y:Y .. P)]]F ev =
       [[! y:Y .. (? x:X -> P)]]F ev"
apply (simp add: Int_bindf_eval)
apply (simp add: Pre_choicef_eval)
apply (simp add: Int_bindf_eval)
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (rule conjI)
apply (intro impI)
apply (erule nonempty_exE)
apply (simp)

apply (intro impI)
apply (elim conjE exE)
apply (erule nonempty_exE)
apply (simp)

apply (rule disjI2)
apply (rule_tac x="aa" in exI)
apply (rule_tac x="s" in exI)
apply (simp)

      (* => *)

apply (simp add: subset_def Ball_def)
done

(*** proc ***)

lemma eq_Pre_choice_Dist:
  "Y ~= {} ==>
       ? x:X -> (! y:Y .. P) =F<ev> ! y:Y .. (? x:X -> P)"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Pre_choicet_Dist)
apply (simp add: eq_Pre_choicef_Dist)
done

(*********************************************************
        Int choice distribution over Ext choice
 *********************************************************)

(*** trace part ***)

lemma eq_Ext_choicet_dist_l: 
  "[[(P1 |~| P2) [+] Q]]T ev = [[P1 [+] Q |~| P2 [+] Q]]T ev"
apply (simp add: Ext_choicet_eval)
apply (simp add: Int_choicet_eval)
apply (simp add: Ext_choicet_eval)
apply (blast)
done

(*** failure part ***)

lemma eq_Ext_choicef_dist_l: 
  "[[(P1 |~| P2) [+] Q]]F ev = [[P1 [+] Q |~| P2 [+] Q]]F ev"
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Ext_choicef_eval)

        (* a = []t & ([]t, b) : [[P1 |~| P2]]F ev & ([]t, b) : [[Q]]F ev *)

apply (erule disjE)
apply (simp add: Int_choicef_eval)
apply (erule conjE)+
apply (erule disjE)
apply (simp add: Ext_choicef_eval)
apply (simp add: Ext_choicef_eval)

        (* a ~= []t & (a, b) : [[P1 |~| P2]]F ev *)

apply (erule disjE)
apply (erule conjE)+
apply (simp add: Int_choicef_eval)
apply (erule disjE)
apply (simp add: Ext_choicef_eval)
apply (simp add: Ext_choicef_eval)

        (* a ~= []t & (a, b) : [[Q]]F ev) *)

apply (simp add: Int_choicef_eval)
apply (simp add: Ext_choicef_eval)

        (* a = []t & b <= Evset & ([Tick]t : [[P1 |~| P2]]T ev *)

apply (erule conjE)+
apply (erule disjE)
apply (simp add: Int_choicet_eval)
apply (blast)

        (* a = []t & [Tick]t : [[Q]]T ev *)

apply (simp)

      (* => *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Int_choicef_eval)

         (* (a, b) : [[P1 [+] Q]]F ev *)

apply (erule disjE)
apply (simp add: Ext_choicef_eval)

            (* a = []t & ([]t, b) : [[P1]]F ev & ([]t, b) : [[Q]]F ev *)

apply (erule disjE)
apply (rule disjI1)
apply (simp add: Int_choicef_eval)

            (* a ~= []t & ((a, b) : [[P1]]F ev | (a, b) : [[Q]]F ev) *)

apply (erule disjE)

apply (rule disjI2)
apply (rule disjI1)
apply (erule conjE)+
apply (erule disjE)
apply (simp add: Int_choicef_eval)
apply (simp add: Int_choicef_eval)

            (* a = []t & b <= Evset & [Tick]t : [[P1]]T ev *)
            (* a = []t & [Tick]t : [[Q]]T ev *)

apply (rule disjI2)
apply (rule disjI2)
apply (erule conjE)+
apply (erule disjE)
apply (simp add: Int_choicet_eval)
apply (simp)

         (* (a, b) : [[P2 [+] Q]]F ev   (symmetric) *)

apply (simp add: Ext_choicef_eval)
apply (erule disjE)
apply (rule disjI1)
apply (simp add: Int_choicef_eval)
apply (erule disjE)

apply (rule disjI2)
apply (rule disjI1)
apply (erule conjE)+
apply (erule disjE)
apply (simp add: Int_choicef_eval)
apply (simp add: Int_choicef_eval)

apply (rule disjI2)
apply (rule disjI2)
apply (erule conjE)+
apply (erule disjE)
apply (simp add: Int_choicet_eval)
apply (simp)
done

(*** proc left ***)

lemma eq_Ext_choice_dist_l: 
  "(P1 |~| P2) [+] Q =F<ev> (P1 [+] Q) |~| (P2 [+] Q)"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Ext_choicet_dist_l)
apply (simp add: eq_Ext_choicef_dist_l)
done

(*** proc right ***)

lemma eq_Ext_choice_dist_r: 
  "P [+] (Q1 |~| Q2) =F<ev> (P [+] Q1) |~| (P [+] Q2)"
apply (rule eqsf_trans)
apply (rule eq_Ext_choice_commut)
apply (rule eqsf_trans)
apply (rule eq_Ext_choice_dist_l)
apply (rule eq_Int_choice_cong)
apply (rule eq_Ext_choice_commut)
apply (rule eq_Ext_choice_commut)
done

(*********************************************************
           Int bind distribution over Ext choice
 *********************************************************)

(*** trace part ***)

lemma eq_Ext_choicet_Dist_l:
  "X ~= {} ==>
       [[(! :X .. Pf) [+] Q]]T ev =  [[! :X .. (%x. (Pf x [+] Q))]]T ev"
apply (simp add: Int_bindt_eval)
apply (simp add: Ext_choicet_eval)
apply (simp add: Int_bindt_eval)
apply (blast)
done

(*** failure part ***)

lemma eq_Ext_choicef_Dist_l:
  "X ~= {} ==>
       [[(! :X .. Pf) [+] Q]]F ev =  [[! :X .. (%x. (Pf x [+] Q))]]F ev"
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Ext_choicef_eval)

        (* a = []t & ([]t, b) : [[! x:X .. P]]F ev & ([]t, b) : [[Q]]F ev *)

apply (erule disjE)
apply (simp add: Int_bindf_eval)
apply (erule conjE)+
apply (elim conjE exE)
apply (rule_tac x="[[Pf aa [+] Q]]F ev" in exI)
apply (rule conjI)
apply (rule_tac x="aa" in exI)
apply (simp)
apply (simp add: Ext_choicef_eval)

        (* a ~= []t & ((a, b) : [[! x:X .. P]]F ev | (a, b) : [[Q]]F ev) *)

apply (erule disjE)
apply (erule conjE)
apply (erule disjE)
apply (simp add: Int_bindf_eval)
apply (elim conjE exE)
apply (rule_tac x="[[Pf aa [+] Q]]F ev" in exI)
apply (rule conjI)
apply (rule_tac x="aa" in exI)
apply (simp)
apply (simp add: Ext_choicef_eval)

apply (simp add: Int_bindf_eval)
apply (erule nonempty_exE)
apply (erule exE)
apply (rule_tac x="[[Pf x [+] Q]]F ev" in exI)
apply (rule conjI)
apply (rule_tac x="x" in exI)
apply (simp)
apply (simp add: Ext_choicef_eval)

        (* b <= Evset &
           ([Tick]t : [[! x:X .. P]]T ev | [Tick]t : [[Q]]T ev) *)

apply (erule conjE)+
apply (erule disjE)

apply (simp add: Int_bindf_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: nil_in_trace event_in_trace Abs_trace_inject)
apply (elim conjE exE)

apply (rule_tac x="[[Pf aa [+] Q]]F ev" in exI)
apply (rule conjI)
apply (rule_tac x="aa" in exI)
apply (simp)
apply (simp add: Ext_choicef_eval)

apply (simp add: Int_bindf_eval)
apply (erule nonempty_exE)
apply (erule exE)
apply (rule_tac x="[[Pf x [+] Q]]F ev" in exI)
apply (rule conjI)
apply (rule_tac x="x" in exI)
apply (simp)
apply (simp add: Ext_choicef_eval)

     (* => *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Int_bindf_eval)
apply (simp add: Ext_choicef_eval)
apply (elim conjE exE)
apply (simp)

        (* 1 *)

apply (erule disjE)
apply (simp add: Int_bindf_eval)
apply (rule disjI1)
apply (rule_tac x="[[Pf aa]]F ev" in exI)
apply (simp)
apply (rule_tac x="aa" in exI)
apply (simp)

        (* 2 *)

apply (erule disjE)
apply (erule conjE)
apply (erule disjE)
apply (simp add: Int_bindf_eval)
apply (rule disjI1)
apply (rule_tac x="[[Pf aa]]F ev" in exI)
apply (simp)
apply (rule_tac x="aa" in exI)
apply (simp)

        (* 3 *)

apply (simp add: Int_bindf_eval)
apply (rule disjI2)
apply (rule disjI2)
apply (simp)

apply (erule conjE)+
apply (erule disjE)
apply (simp add: Int_bindt_eval)
apply (rule disjI2)
apply (rule disjI1)
apply (rule_tac x="[[Pf aa]]T ev" in exI)
apply (simp)
apply (rule_tac x="aa" in exI)
apply (simp)
apply (simp)
done

(*** proc left ***)

lemma eq_Ext_choice_Dist_l: 
  "X ~= {} ==>
       (! :X .. Pf) [+] Q =F<ev> ! :X .. (%x. (Pf x [+] Q))"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Ext_choicet_Dist_l)
apply (simp add: eq_Ext_choicef_Dist_l)
done

(*** proc right ***)

lemma eq_Ext_choice_Dist_r: 
  "X ~= {} ==>
       P [+] (! :X .. Qf) =F<ev> ! :X .. (%x. (P [+] Qf x))"
apply (rule eqsf_trans)
apply (rule eq_Ext_choice_commut)
apply (rule eqsf_trans)
apply (rule eq_Ext_choice_Dist_l, simp)
apply (rule eq_Int_bind_cong)
apply (rule eq_Ext_choice_commut)
done

(*********************************************************
          Int choice distribution over Parallel
 *********************************************************)

(*** trace part ***)

lemma eq_Parallelt_dist_l: 
    "[[(P1 |~| P2) |[X]| Q]]T ev 
   = [[(P1 |[X]| Q) |~| (P2 |[X]| Q)]]T ev"
apply (simp add: Parallelt_eval)
apply (simp add: Int_choicet_eval)
apply (simp add: Parallelt_eval)
apply (simp add: Parallelt_def)
apply (blast)
done

(*** failure part ***)

lemma eq_Parallelf_dist_l: 
    "[[(P1 |~| P2) |[X]| Q]]F ev 
   = [[(P1 |[X]| Q) |~| (P2 |[X]| Q)]]F ev"
apply (simp add: Parallelf_eval)
apply (simp add: Int_choicef_eval)
apply (simp add: Parallelf_eval)
apply (simp add: Parallelf_def)
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (elim conjE exE)
apply (erule disjE)

apply (rule disjI1)
apply (rule_tac x="Y" in exI)
apply (rule_tac x="Z" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)

apply (rule disjI2)
apply (rule_tac x="Y" in exI)
apply (rule_tac x="Z" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)

      (* => *)

apply (simp add: subset_def Ball_def)
apply (intro allI)
apply (rule conjI)

apply (intro impI)
apply (elim conjE exE)
apply (rule_tac x="Y" in exI)
apply (rule_tac x="Z" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)

apply (intro impI)
apply (elim conjE exE)
apply (rule_tac x="Y" in exI)
apply (rule_tac x="Z" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)
done

(*** proc left ***)

lemma eq_Parallel_dist_l:
  "(P1 |~| P2) |[X]| Q =F<ev>
   (P1 |[X]| Q) |~| (P2 |[X]| Q)"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Parallelt_dist_l)
apply (simp add: eq_Parallelf_dist_l)
done

(*** proc right ***)

lemma eq_Parallel_dist_r:
  "P |[X]| (Q1 |~| Q2) =F<ev>
   (P |[X]| Q1) |~| (P |[X]| Q2)"
apply (rule eqsf_trans)
apply (rule eq_Parallel_commut)
apply (rule eqsf_trans)
apply (rule eq_Parallel_dist_l)
apply (rule eq_Int_choice_cong)
apply (rule eq_Parallel_commut)
apply (rule eq_Parallel_commut)
done

(*********************************************************
           Int bind distribution over Parallel
 *********************************************************)

(*** trace part ***)

lemma eq_Parallelt_Dist_l: 
  "Y ~= {} ==>
       [[(! :Y .. Pf) |[X]| Q]]T ev 
     = [[! :Y .. (%x. (Pf x |[X]| Q))]]T ev"
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Parallelt_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: Parallelt_def)
apply (elim conjE exE)
apply (erule disjE)

apply (rule disjI2)
apply (erule nonempty_exE)
apply (erule exE)
apply (rule_tac x="[[Pf xb |[X]| Q]]T ev" in exI)
apply (rule conjI)
apply (rule_tac x="xb" in exI)
apply (simp)

apply (simp add: Parallelt_eval)
apply (simp add: Parallelt_def)
apply (rule_tac x="s |[X]|set t" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp add: eval_T_in nil_t_in_all_dom)

apply (rule disjI2)
apply (elim conjE exE)
apply (rule_tac x="[[Pf a |[X]| Q]]T ev" in exI)
apply (rule conjI)
apply (rule_tac x="a" in exI)
apply (simp)

apply (simp add: Parallelt_eval)
apply (simp add: Parallelt_def)
apply (rule_tac x="s |[X]|set t" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)

      (* => *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Parallelt_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: Parallelt_eval)
apply (simp add: Parallelt_def)
apply (erule disjE)

apply (rule_tac x="[]t |[X]|set []t" in exI)
apply (simp add: par_trace_nil)
apply (rule_tac x="[]t" in exI)
apply (rule_tac x="[]t" in exI)
apply (simp add: eval_T_in nil_t_in_all_dom)

apply (elim conjE exE)
apply (simp)
apply (elim conjE exE)
apply (rule_tac x="s |[X]|set t" in exI)
apply (simp)

apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)

apply (rule disjI2)
apply (rule_tac x="[[Pf a]]T ev" in exI)
apply (simp)
apply (rule_tac x="a" in exI)
apply (simp)
done

(*** failure part ***)

lemma eq_Parallelf_Dist_l: 
  "Y ~= {} ==>
       [[(! :Y .. Pf) |[X]| Q]]F ev 
           = [[! :Y .. (%x. (Pf x |[X]| Q))]]F ev"
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Parallelf_eval)
apply (simp add: Int_bindf_eval)
apply (simp add: Parallelf_def)
apply (elim conjE exE)

apply (rule_tac x="[[Pf aa |[X]| Q]]F ev" in exI)
apply (rule conjI)
apply (rule_tac x="aa" in exI)
apply (simp)

apply (simp add: Parallelf_eval)
apply (simp add: Parallelf_def)
apply (rule_tac x="Ya" in exI)
apply (rule_tac x="Z" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)

      (* => *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Parallelf_eval)
apply (simp add: Int_bindf_eval)
apply (simp add: Parallelf_eval)
apply (elim conjE exE)
apply (simp)
apply (simp add: Parallelf_def)
apply (elim conjE exE)

apply (rule_tac x="Ya" in exI)
apply (rule_tac x="Z" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)

apply (rule_tac x="[[Pf aa]]F ev" in exI)
apply (simp)
apply (rule_tac x="aa" in exI)
apply (simp)
done

(*** proc left ***)

lemma eq_Parallel_Dist_l: 
  "Y ~= {} ==>
    (! :Y .. Pf) |[X]| Q =F<ev> ! :Y .. (%x. (Pf x |[X]| Q))"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Parallelt_Dist_l)
apply (simp add: eq_Parallelf_Dist_l)
done

(*** proc right ***)

lemma eq_Parallel_Dist_r: 
  "Y ~= {} ==>
    P |[X]| (! :Y .. Qf) =F<ev> ! :Y .. (%x. (P |[X]| Qf x))"
apply (rule eqsf_trans)
apply (rule eq_Parallel_commut)
apply (rule eqsf_trans)
apply (rule eq_Parallel_Dist_l, simp)
apply (rule eq_Int_bind_cong)
apply (rule eq_Parallel_commut)
done

(*********************************************************
           Int choice distribution over Hide
 *********************************************************)

(*** trace part ***)

lemma eq_Hidet_dist: 
  "[[(P |~| Q) -- X]]T ev = [[(P -- X) |~| (Q -- X)]]T ev"
apply (simp add: Hidet_eval)
apply (simp add: Int_choicet_eval)
apply (simp add: Hidet_eval)
apply (simp add: Hidet_def)
apply (blast)
done

(*** failure part ***)

lemma eq_Hidef_dist: 
  "[[(P |~| Q) -- X]]F ev = [[(P -- X) |~| (Q -- X)]]F ev"
apply (simp add: Hidef_eval)
apply (simp add: Int_choicef_eval)
apply (simp add: Hidef_eval)
apply (simp add: Hidef_def)
apply (blast)
done

(*** proc ***)

lemma eq_Hide_dist:
  "(P |~| Q) -- X =F<ev> (P -- X) |~| (Q -- X)"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Hidet_dist)
apply (simp add: eq_Hidef_dist)
done

(*********************************************************
             Int bind distribution over Hide
 *********************************************************)

(*** trace part ***)

lemma eq_Hidet_Dist: 
  "Y ~= {} ==>
     [[(! :Y .. Pf) -- X]]T ev = [[! :Y .. (%x. (Pf x -- X))]]T ev"
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Hidet_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: Hidet_eval)
apply (simp add: Hidet_def)
apply (elim conjE exE)
apply (erule disjE)
apply (simp add: hide_trace_nil)

apply (rule disjI2)
apply (elim conjE exE)
apply (rule_tac x="{t --tr X |t. t : [[Pf a]]T ev}" in exI)
apply (rule conjI)
apply (rule_tac x="a" in exI)
apply (simp)

apply (simp)
apply (rule_tac x="t" in exI)
apply (simp)

      (* => *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Hidet_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: Hidet_eval)
apply (simp add: Hidet_def)
apply (erule disjE)
apply (rule_tac x="[]t" in exI)
apply (simp add: hide_trace_nil)

apply (elim conjE exE)
apply (simp)
apply (elim conjE exE)
apply (rule_tac x="t" in exI)
apply (simp)
apply (rule disjI2)
apply (rule_tac x="[[Pf a]]T ev" in exI)
apply (simp)
apply (rule_tac x="a" in exI)
apply (simp)
done

(*** failure part ***)

lemma eq_Hidef_Dist: 
  "Y ~= {} ==>
     [[(! :Y .. Pf) -- X]]F ev = [[! :Y .. (%x. (Pf x -- X))]]F ev"
apply (rule equalityI)

      (* <= *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Hidef_eval)
apply (simp add: Int_bindf_eval)
apply (simp add: Hidef_eval)
apply (simp add: Hidef_def)
apply (elim conjE exE)
apply (rule_tac x="{(t --tr X, Y) |t Y.
                    (t, Ev ` X Un Y) : [[Pf aa]]F ev}" in exI)
apply (rule conjI)
apply (rule_tac x="aa" in exI)
apply (simp)

apply (simp)
apply (rule_tac x="t" in exI)
apply (simp)

      (* => *)

apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (simp add: Hidef_eval)
apply (simp add: Int_bindf_eval)
apply (simp add: Hidef_eval)
apply (elim conjE exE)
apply (insert Hidef_mono)
apply (drule_tac x="X" in spec)
apply (drule_tac x="[[Pf aa]]F ev" in spec)
apply (drule_tac x="Union {[[Pf a]]F ev |a. a : Y}" in spec)
apply (drule mp)
apply (simp add: subset_def Ball_def)
apply (intro allI impI)
apply (rule_tac x="[[Pf aa]]F ev" in exI)
apply (simp)
apply (rule_tac x="aa" in exI)
apply (auto)
done

(*** proc ***)

lemma eq_Hide_Dist: 
  "Y ~= {} ==>
     (! :Y .. Pf) -- X =F<ev> ! :Y .. (%x. (Pf x -- X))"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Hidet_Dist)
apply (simp add: eq_Hidef_Dist)
done

end
