           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |                June 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM16_Spc_Seq = DM15_Spc_Seq:

(*****************************************************************

         1. proves lemma for Spc <=F Seq
         2.
         3. 
         4. 

 *****************************************************************)

(*** TH0_TH1 (Seq_TH0_Back1) ***)

lemma TH0_TH1_Seq_TH0_Back1_EVEN[simp]:
   "EVEN n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>) 
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN Back1 -> <Seq_TH0_TH1 n> 
        [> (Eat0 -> <Seq_EAT0_Back1 n> [+] Back1 -> <Seq_Eat0_TH1 n>)"
apply (rule csp_Timeout_right)

(* 1 *)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})

(* 2 *)
apply (tactic {* csp_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

lemma TH0_TH1_Seq_TH0_Back1_ODD[simp]:
   "LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>) 
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN Back1 -> <Seq_TH0_TH1 n> 
        [> (Back0 -> <Seq_TH0_Back1 n> [+] Back1 -> <Seq_Back0_TH1 n>)"
apply (rule csp_Timeout_right)

(* 1 *)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})

(* 2 *)
apply (tactic {* csp_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

(*** TH0_TH1 (Seq_Back0_TH1) ***)

lemma TH0_TH1_Seq_Back0_TH1_EVEN[simp]:
   "EVEN n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN Back0 -> <Seq_TH0_TH1 n> 
        [> (Back0 -> <Seq_TH0_Back1 n> [+] Back1 -> <Seq_Back0_TH1 n>)"
apply (rule csp_Timeout_right)

(* 1 *)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})

(* 2 *)
apply (tactic {* csp_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

lemma TH0_TH1_Seq_Back0_TH1_ODD[simp]:
   "ODD n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN Back0 -> <Seq_TH0_TH1 n> 
        [> (Eat1 -> <Seq_Back0_EAT1 n> [+] Back0 -> <Seq_TH0_Eat1 n>)"
apply (rule csp_Timeout_right)

(* 1 *)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})

(* 2 *)
apply (tactic {* csp_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

(*** TH0_TH1 (Seq_TH0_Eat1) ***)

lemma TH0_TH1_Seq_TH0_Eat1[simp]:
   "ODD n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
        IN Eat1 -> <Seq_TH0_EAT1 n> 
            [> (Eat1 -> <Seq_Back0_EAT1 n> [+] Back0 -> <Seq_TH0_Eat1 n>)"
apply (rule csp_Timeout_right)

(* 1 *)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})

(* 2 *)
apply (tactic {* csp_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

(*** TH0_TH1 (Seq_Eat0_TH1) ***)

lemma TH0_TH1_Seq_Eat0_TH1[simp]:
   "EVEN n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef
    IN Eat0 -> <Seq_EAT0_TH1 n> 
            [> (Eat0 -> <Seq_EAT0_Back1 n> [+] Back1 -> <Seq_Eat0_TH1 n>)"
apply (rule csp_Timeout_right)

(* 1 *)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})

(* 2 *)
apply (tactic {* csp_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

(*** TH0_TH1 (Seq_TH0_TH1) ***)

lemma TH0_TH1_Seq_TH0_TH1_EVEN[simp]:
   "EVEN n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN (Eat0 -> <Seq_EAT0_TH1 n> 
              [> (Eat0 -> <Seq_EAT0_Back1 n> [+] Back1 -> <Seq_Eat0_TH1 n>))
        |~| 
       (Back1 -> <Seq_TH0_TH1 n> 
              [> (Eat0 -> <Seq_EAT0_Back1 n> [+] Back1 -> <Seq_Eat0_TH1 n>))"
apply (rule)
apply (tactic {* csp_simp_tac 1 *})
done

lemma TH0_TH1_Seq_TH0_TH1_ODD[simp]:
   "ODD n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN  (Back0 -> <Seq_TH0_TH1 n> 
              [> (Eat1 -> <Seq_Back0_EAT1 n> [+] Back0 -> <Seq_TH0_Eat1 n>))
        |~| 
        (Eat1 -> <Seq_TH0_EAT1 n> 
              [> (Eat1 -> <Seq_Back0_EAT1 n> [+] Back0 -> <Seq_TH0_Eat1 n>))"
apply (rule)
apply (tactic {* csp_simp_tac 1 *})
done

(*** TH0_TH1 (Seq_Back0_WR1) ***)

lemma TH0_TH1_Seq_Back0_WR1[simp]:
   "ODD n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
     LET SeqDef 
        IN Back0 -> <Seq_TH0_WR1 n> 
                 [> (Back0 -> <Seq_TH0_TH1 (3 * n + 1)> 
                      [> (Back0 -> <Seq_TH0_Back1 (3 * n + 1)> 
                           [+] Back1 -> <Seq_Back0_TH1 (3 * n + 1)>))"
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

(*** TH0_TH1 (Seq_WR0_Back1) ***)

lemma TH0_TH1_Seq_WR0_Back1_EVEN[simp]:
   "[| EVEN n ; EVEN (n div 2) |] ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN Back1 -> <Seq_WR0_TH1 n> 
                 [> (Back1 -> <Seq_TH0_TH1 (n div 2)> 
                      [> (Eat0 -> <Seq_EAT0_Back1 (n div 2)>
                          [+] Back1 -> <Seq_Eat0_TH1 (n div 2)>))"
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

lemma TH0_TH1_Seq_WR0_Back1_ODD[simp]:
   "[| EVEN n ; ODD (n div 2) |] ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN Back1 -> <Seq_WR0_TH1 n> 
                 [> (Back1 -> <Seq_TH0_TH1 (n div 2)> 
                      [> (Back0 -> <Seq_TH0_Back1 (n div 2)> 
                               [+] Back1 -> <Seq_Back0_TH1 (n div 2)>))"
apply (rule csp_Timeout_right)
apply (tactic {* csp_light_step_right_tac 1 *})
apply (auto intro!: csp_Int_bind_Pre_choice_subset)
apply (tactic {* csp_simp_tac 1 *})
done

(*** TH0_TH1 (Seq_TH0_WR1) ***)

lemma TH0_TH1_Seq_TH0_WR1[simp]:
   "ODD n ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
     LET SeqDef 
     IN Eat0 -> <Seq_EAT0_TH1 (3 * n + 1)> 
            [> (Eat0 -> <Seq_EAT0_Back1 (3 * n + 1)> 
                 [+] Back1 -> <Seq_Eat0_TH1 (3 * n + 1)>) 
            |~| Back1 -> <Seq_TH0_TH1 (3 * n + 1)> 
                 [> (Eat0 -> <Seq_EAT0_Back1 (3 * n + 1)> 
                      [+] Back1 -> <Seq_Eat0_TH1 (3 * n + 1)>) 
            |~| Back0 -> <Seq_TH0_WR1 n> 
                 [> (Back0 -> <Seq_TH0_TH1 (3 * n + 1)> 
                      [> (Back0 -> <Seq_TH0_Back1 (3 * n + 1)> 
                           [+] Back1 -> <Seq_Back0_TH1 (3 * n + 1)>))"
apply (auto)
done

(*** TH0_TH1 (Seq_WR0_TH1) ***)

lemma TH0_TH1_Seq_WR0_TH1_EVEN[simp]:
   "[| EVEN n ; EVEN (n div 2) |] ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN (Eat0 -> <Seq_EAT0_TH1 (n div 2)> 
         [> (Eat0 -> <Seq_EAT0_Back1 (n div 2)> 
           [+] Back1 -> <Seq_Eat0_TH1 (n div 2)>))
                 |~| 
       (Back1 -> <Seq_TH0_TH1 (n div 2)> 
         [> (Eat0 -> <Seq_EAT0_Back1 (n div 2)> 
           [+] Back1 -> <Seq_Eat0_TH1 (n div 2)>))
                 |~| (Back1 -> <Seq_WR0_TH1 n> 
                      [> (Back1 -> <Seq_TH0_TH1 (n div 2)> 
                           [> (Eat0 -> <Seq_EAT0_Back1 (n div 2)> 
                                    [+] Back1 -> <Seq_Eat0_TH1 (n div 2)>)))"
apply (rule)
apply (tactic {* csp_simp_tac 1 *})+
done

lemma TH0_TH1_Seq_WR0_TH1_ODD[simp]:
   "[| EVEN n ; ODD (n div 2) |] ==>
    LET SeqDef 
    IN ! x:OBS .. 
        x -> IF (x = Eat0) 
             THEN (    ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                   |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)>)
             ELSE IF (x = Eat1) 
                  THEN (    ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>)
                  ELSE (    ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                        |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                        |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                        |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>)
     <=F 
    LET SeqDef 
    IN (Back0 -> <Seq_TH0_TH1 (n div 2)> 
                      [> (Eat1 -> <Seq_Back0_EAT1 (n div 2)>
                           [+] Back0 -> <Seq_TH0_Eat1 (n div 2)>))
                 |~| 
                (Eat1 -> <Seq_TH0_EAT1 (n div 2)> 
                      [> (Eat1 -> <Seq_Back0_EAT1 (n div 2)>
                           [+] Back0 -> <Seq_TH0_Eat1 (n div 2)>))
                 |~| (Back1 -> <Seq_WR0_TH1 n> 
                      [> (Back1 -> <Seq_TH0_TH1 (n div 2)> 
                           [> (Back0 -> <Seq_TH0_Back1 (n div 2)> 
                                    [+] Back1 -> <Seq_Back0_TH1 (n div 2)>)))"
apply (rule)
apply (tactic {* csp_simp_tac 1 *})+
done

end
